package ch.std.jumpstart.rest;

import java.util.List;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import ch.std.jumpstart.dto.CityDTO;
import ch.std.jumpstart.jpa.City;
import ch.std.jumpstart.service.CityService;

@RestController
public class CityAutoJpaCompleteController {
	
	@Autowired
	private CityService cityService;
	
	@Autowired
	private ModelMapper modelMapper;

	@GetMapping("/rest/auto/citiesjpa")
	public CityDTO[] autoComplete(@RequestParam(value = "value") String value) {
		List<City> cities = (List<City>) this.cityService.find(value);
		return cities.stream().map(city -> convertToDTO(city)).toArray(CityDTO[]::new);
	}

	private CityDTO convertToDTO(City city) {
		return this.modelMapper.map(city, CityDTO.class);
	}
}
